//require base/meta.js
//require base/base.js

(function($)
{

var width = -1;

var pageMeta = meta.getPageMetaData();

var $window = $(window);
var safety = 4;
var scrollbarWidth = null;
this.dynlayout =  
{
columnCount: pageMeta.grid.columnCount,
windowWidth: 
    function()
    {
        return $window.width();
    },
windowHeight: 
    function()
    {
        return $window.height();
    },
width:
    function()
    {
        var windowWidth = dynlayout.windowWidth();
        // substract safety, round down to next evenly column count divideable   
        windowWidth = $(document.body).hasClass("presentation") ? 1040 : windowWidth;
        windowWidth = windowWidth - safety - dynlayout.scrollbarAdjust();
        
        windowWidth = Math.floor(windowWidth / this.columnCount) * this.columnCount; 
        return windowWidth;
    },
scrollbarAdjust:
    function()
    {
        var $body = $(document.body);
        if ($body.height() <= $window.height())
        {
            if (!scrollbarWidth)
            {
                var $div = $('<div style="width:50px;height:50px;overflow:hidden;position:absolute;top:-200px;left:-200px;"><div style="height:100px;"></div>');
                // Append our div, do our calculation and then remove it
                $(document.body).append($div);
                
                var $innerDiv = $div.find("div"); 
                
                var width = $innerDiv.innerWidth();
                $div.css("overflow", "auto");
                var sbWidth = $innerDiv.innerWidth();
                $div.remove();
                scrollbarWidth = (width - sbWidth);
                
                //console.debug("scrollbar width = %d", scrollbarWidth);
            }
            return scrollbarWidth;
        }
        else
        {
            return 0;
        }       
    }
};

})(jQuery);

ScriptLoader.signalLoaded("base/dynlayout.js");
